"""
    EMIL InsuranceService

    The EMIL InsuranceService API description  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@emil.de
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from eis.insurance.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from eis.insurance.exceptions import ApiAttributeError


def lazy_import():
    from eis.insurance.model.create_account_request_dto import CreateAccountRequestDto
    from eis.insurance.model.create_lead_policy_request_dto import CreateLeadPolicyRequestDto
    from eis.insurance.model.create_payment_method_request_dto import CreatePaymentMethodRequestDto
    from eis.insurance.model.lead_bank_account_class import LeadBankAccountClass
    from eis.insurance.model.partner_link_class import PartnerLinkClass
    from eis.insurance.model.premium_override_request_class import PremiumOverrideRequestClass
    from eis.insurance.model.shared_invoice_class import SharedInvoiceClass
    from eis.insurance.model.uploaded_document_dto import UploadedDocumentDto
    globals()['CreateAccountRequestDto'] = CreateAccountRequestDto
    globals()['CreateLeadPolicyRequestDto'] = CreateLeadPolicyRequestDto
    globals()['CreatePaymentMethodRequestDto'] = CreatePaymentMethodRequestDto
    globals()['LeadBankAccountClass'] = LeadBankAccountClass
    globals()['PartnerLinkClass'] = PartnerLinkClass
    globals()['PremiumOverrideRequestClass'] = PremiumOverrideRequestClass
    globals()['SharedInvoiceClass'] = SharedInvoiceClass
    globals()['UploadedDocumentDto'] = UploadedDocumentDto


class LeadClass(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (float,),  # noqa: E501
            'code': (str,),  # noqa: E501
            'ern': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'account': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'policy': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
            'validate': (bool,),  # noqa: E501
            'lead_number': (str,),  # noqa: E501
            'partner_links': ([PartnerLinkClass],),  # noqa: E501
            'account_code': (str,),  # noqa: E501
            'bank_account': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'custom_data': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'uploaded_document': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'premium_override': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'product_slug': (str,),  # noqa: E501
            'quote': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'payment_method': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'version': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'code': 'code',  # noqa: E501
        'ern': 'ern',  # noqa: E501
        'status': 'status',  # noqa: E501
        'account': 'account',  # noqa: E501
        'policy': 'policy',  # noqa: E501
        'created_at': 'createdAt',  # noqa: E501
        'updated_at': 'updatedAt',  # noqa: E501
        'validate': 'validate',  # noqa: E501
        'lead_number': 'leadNumber',  # noqa: E501
        'partner_links': 'partnerLinks',  # noqa: E501
        'account_code': 'accountCode',  # noqa: E501
        'bank_account': 'bankAccount',  # noqa: E501
        'custom_data': 'customData',  # noqa: E501
        'uploaded_document': 'uploadedDocument',  # noqa: E501
        'premium_override': 'premiumOverride',  # noqa: E501
        'product_slug': 'productSlug',  # noqa: E501
        'quote': 'quote',  # noqa: E501
        'payment_method': 'paymentMethod',  # noqa: E501
        'version': 'version',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, code, ern, status, account, policy, created_at, updated_at, validate, lead_number, partner_links, *args, **kwargs):  # noqa: E501
        """LeadClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.
            status (str): Lead status.
            account (bool, date, datetime, dict, float, int, list, str, none_type): Lead account.
            policy (bool, date, datetime, dict, float, int, list, str, none_type): Lead policy.
            created_at (datetime): Time at which the object was created.
            updated_at (datetime): Time at which the object was updated.
            validate (bool): A indicator to validate the lead.
            lead_number (str): Lead number.
            partner_links ([PartnerLinkClass]): Partner links.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_code (str): Unique identifier of the account that this object belongs to.. [optional]  # noqa: E501
            bank_account (bool, date, datetime, dict, float, int, list, str, none_type): Lead bank account, will be treated as a reference to payout customer claims.. [optional]  # noqa: E501
            custom_data ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Custom data for custom application creation.. [optional]  # noqa: E501
            uploaded_document (bool, date, datetime, dict, float, int, list, str, none_type): List of uploaded document codes.. [optional]  # noqa: E501
            premium_override (bool, date, datetime, dict, float, int, list, str, none_type): Override for premium calculation. Leave null for default calculation.. [optional]  # noqa: E501
            product_slug (str): A slug is a human-readable, unique identifier, used to identify a resource     instead of a less human-readable identifier like an id.. [optional]  # noqa: E501
            quote (bool, date, datetime, dict, float, int, list, str, none_type): Quote or price details.. [optional]  # noqa: E501
            payment_method (bool, date, datetime, dict, float, int, list, str, none_type): Payment method. When a payment method is provided, it needs to be handled in the workflow based on its type.. [optional]  # noqa: E501
            version (float): Lead version.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.ern = ern
        self.status = status
        self.account = account
        self.policy = policy
        self.created_at = created_at
        self.updated_at = updated_at
        self.validate = validate
        self.lead_number = lead_number
        self.partner_links = partner_links
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, code, ern, status, account, policy, created_at, updated_at, validate, lead_number, partner_links, *args, **kwargs):  # noqa: E501
        """LeadClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.
            status (str): Lead status.
            account (bool, date, datetime, dict, float, int, list, str, none_type): Lead account.
            policy (bool, date, datetime, dict, float, int, list, str, none_type): Lead policy.
            created_at (datetime): Time at which the object was created.
            updated_at (datetime): Time at which the object was updated.
            validate (bool): A indicator to validate the lead.
            lead_number (str): Lead number.
            partner_links ([PartnerLinkClass]): Partner links.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_code (str): Unique identifier of the account that this object belongs to.. [optional]  # noqa: E501
            bank_account (bool, date, datetime, dict, float, int, list, str, none_type): Lead bank account, will be treated as a reference to payout customer claims.. [optional]  # noqa: E501
            custom_data ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Custom data for custom application creation.. [optional]  # noqa: E501
            uploaded_document (bool, date, datetime, dict, float, int, list, str, none_type): List of uploaded document codes.. [optional]  # noqa: E501
            premium_override (bool, date, datetime, dict, float, int, list, str, none_type): Override for premium calculation. Leave null for default calculation.. [optional]  # noqa: E501
            product_slug (str): A slug is a human-readable, unique identifier, used to identify a resource     instead of a less human-readable identifier like an id.. [optional]  # noqa: E501
            quote (bool, date, datetime, dict, float, int, list, str, none_type): Quote or price details.. [optional]  # noqa: E501
            payment_method (bool, date, datetime, dict, float, int, list, str, none_type): Payment method. When a payment method is provided, it needs to be handled in the workflow based on its type.. [optional]  # noqa: E501
            version (float): Lead version.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.ern = ern
        self.status = status
        self.account = account
        self.policy = policy
        self.created_at = created_at
        self.updated_at = updated_at
        self.validate = validate
        self.lead_number = lead_number
        self.partner_links = partner_links
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
